Subject: Re: bug#33968: errors in shepherd service constructors are not logged and lead to misleading status

From: Ludovic Courtès <[email-masked]>
Date: Thu, 15 Jun 2023 23:15:29 +0200

Florian Dold <[email-masked]> skribis:

> when defining a service type that extends shepherd-root-service-type and
> the 'start' function of the shepherd-service definition contains an
> error, the error is silently ignored.  No log output is generated at all.

[...]

> I generally feel like the state machine for services needs some work.
> In particular, it would be useful to distinguish between "failed" and
> "completed" services instead of conflating both states into "stopped".
> Or maybe have some more general mechanism for storing state about the
> service, instead of just the slot that usually contains the PID?

It’s been 4 years (!) but the good news is that all this is fixed as of
Shepherd 0.10.  Closing!

Ludo’.